/* ***********************************************************
 * This file was automatically generated on 2018-09-28.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.18                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures distance between 2cm and 400cm with ultrasound
	/// </summary>
	public class BrickletDistanceUS : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 229;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Distance US Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE_VALUE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_MOVING_AVERAGE = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOVING_AVERAGE = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_DISTANCE = 8;

		private const int CALLBACK_DISTANCE_REACHED = 9;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackPeriod"/>. The parameter is the distance value
		///  of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletDistanceUS.DistanceCallback"/> callback is only triggered if the distance value has changed
		///  since the last triggering.
		/// </summary>
		public event DistanceEventHandler DistanceCallback;
		/// <summary>
		/// </summary>
		public delegate void DistanceEventHandler(BrickletDistanceUS sender, int distance);

		/// <summary>
		/// </summary>
		public event DistanceEventHandler Distance // for backward compatibility
		{
			add { DistanceCallback += value; }
			remove { DistanceCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackThreshold"/> is reached.
		///  The parameter is the distance value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletDistanceUS.SetDebouncePeriod"/>.
		/// </summary>
		public event DistanceReachedEventHandler DistanceReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void DistanceReachedEventHandler(BrickletDistanceUS sender, int distance);

		/// <summary>
		/// </summary>
		public event DistanceReachedEventHandler DistanceReached // for backward compatibility
		{
			add { DistanceReachedCallback += value; }
			remove { DistanceReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletDistanceUS(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_DISTANCE] = new CallbackWrapper(OnDistanceCallback);
			callbackWrappers[CALLBACK_DISTANCE_REACHED] = new CallbackWrapper(OnDistanceReachedCallback);


			responseExpected[FUNCTION_GET_DISTANCE_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DISTANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DISTANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MOVING_AVERAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MOVING_AVERAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Returns the current distance value measured by the sensor. The value has a
		///  range of 0 to 4095. A small value corresponds to a small distance, a big
		///  value corresponds to a big distance. The relation between the measured distance
		///  value and the actual distance is affected by the 5V supply voltage (deviations
		///  in the supply voltage result in deviations in the distance values) and is
		///  non-linear (resolution is bigger at close range).
		///  
		///  If you want to get the distance value periodically, it is recommended to
		///  use the <see cref="Tinkerforge.BrickletDistanceUS.DistanceCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public int GetDistanceValue()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE_VALUE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletDistanceUS.DistanceCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  Der <see cref="Tinkerforge.BrickletDistanceUS.DistanceCallback"/> callback is only triggered if the distance value has changed
		///  since the last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetDistanceCallbackPeriod(long period)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DISTANCE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public long GetDistanceCallbackPeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletDistanceUS.DistanceReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the distance value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the distance value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the distance value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the distance value is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetDistanceCallbackThreshold(char option, int min, int max)
		{
			byte[] request = CreateRequestPacket(13, FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackThreshold"/>.
		/// </summary>
		public void GetDistanceCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletDistanceUS.DistanceReachedCallback"/>,
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletDistanceUS.SetDistanceCallbackThreshold"/>,
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletDistanceUS.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
		///  for the distance value.
		///  
		///  Setting the length to 0 will turn the averaging completely off. With less
		///  averaging, there is more noise on the data.
		///  
		///  The range for the averaging is 0-100.
		///  
		///  The default value is 20.
		/// </summary>
		public void SetMovingAverage(byte average)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_MOVING_AVERAGE);
			LEConverter.To((byte)average, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the length moving average as set by <see cref="Tinkerforge.BrickletDistanceUS.SetMovingAverage"/>.
		/// </summary>
		public byte GetMovingAverage()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOVING_AVERAGE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnDistanceCallback(byte[] response)
		{
			int distance = LEConverter.UShortFrom(8, response);
			var handler = DistanceCallback;

			if (handler != null)
			{
				handler(this, distance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnDistanceReachedCallback(byte[] response)
		{
			int distance = LEConverter.UShortFrom(8, response);
			var handler = DistanceReachedCallback;

			if (handler != null)
			{
				handler(this, distance);
			}
		}
	}
}
