/* ***********************************************************
 * This file was automatically generated on 2018-09-28.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.18                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA
	/// </summary>
	public class BrickletIndustrialAnalogOut : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 258;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Industrial Analog Out Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_ENABLE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_DISABLE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_IS_ENABLED = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_VOLTAGE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_VOLTAGE = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_CONFIGURATION = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_CONFIGURATION = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte VOLTAGE_RANGE_0_TO_5V = 0;

		/// <summary>
		/// </summary>
		public const byte VOLTAGE_RANGE_0_TO_10V = 1;

		/// <summary>
		/// </summary>
		public const byte CURRENT_RANGE_4_TO_20MA = 0;

		/// <summary>
		/// </summary>
		public const byte CURRENT_RANGE_0_TO_20MA = 1;

		/// <summary>
		/// </summary>
		public const byte CURRENT_RANGE_0_TO_24MA = 2;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletIndustrialAnalogOut(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;



			responseExpected[FUNCTION_ENABLE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DISABLE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_ENABLED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_VOLTAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CURRENT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CURRENT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Enables the output of voltage and current.
		///  
		///  The default is disabled.
		/// </summary>
		public void Enable()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_ENABLE);

			SendRequest(request);

		}

		/// <summary>
		///  Disables the output of voltage and current.
		///  
		///  The default is disabled.
		/// </summary>
		public void Disable()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_DISABLE);

			SendRequest(request);

		}

		/// <summary>
		///  Returns *true* if output of voltage and current is enabled, *false* otherwise.
		/// </summary>
		public bool IsEnabled()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_IS_ENABLED);

			byte[] response = SendRequest(request);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Sets the output voltage in mV.
		///  
		///  The output voltage and output current are linked. Changing the output voltage
		///  also changes the output current.
		/// </summary>
		public void SetVoltage(int voltage)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_VOLTAGE);
			LEConverter.To((short)voltage, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the voltage as set by <see cref="Tinkerforge.BrickletIndustrialAnalogOut.SetVoltage"/>.
		/// </summary>
		public int GetVoltage()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_VOLTAGE);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the output current in µA.
		///  
		///  The output current and output voltage are linked. Changing the output current
		///  also changes the output voltage.
		/// </summary>
		public void SetCurrent(int current)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_CURRENT);
			LEConverter.To((short)current, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current as set by <see cref="Tinkerforge.BrickletIndustrialAnalogOut.SetCurrent"/>.
		/// </summary>
		public int GetCurrent()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT);

			byte[] response = SendRequest(request);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Configures the voltage and current range.
		///  
		///  Possible voltage ranges are:
		///  
		///  * 0V to 5V
		///  * 0V to 10V (default)
		///  
		///  Possible current ranges are:
		///  
		///  * 4mA to 20mA (default)
		///  * 0mA to 20mA
		///  * 0mA to 24mA
		///  
		///  The resolution will always be 12 bit. This means, that the
		///  precision is higher with a smaller range.
		/// </summary>
		public void SetConfiguration(byte voltageRange, byte currentRange)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_CONFIGURATION);
			LEConverter.To((byte)voltageRange, 8, request);
			LEConverter.To((byte)currentRange, 9, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletIndustrialAnalogOut.SetConfiguration"/>.
		/// </summary>
		public void GetConfiguration(out byte voltageRange, out byte currentRange)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CONFIGURATION);

			byte[] response = SendRequest(request);

			voltageRange = LEConverter.ByteFrom(8, response);
			currentRange = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}
